SystemOrganization addCategory: #Jihachol!

TestCase subclass: #JhcBundangLineTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcBundangLineTest methodsFor: 'running' stamp: 'hjo 9/28/2009 13:12'!
setUp

	super setUp.
	line := JhcLine bundang.
	
	

	! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:35'!
testDogok

	| s |
	s := line stations at: 3.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Dogok'.
	self assert: s id equals: 'K217'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:40'!
testGaepoDong

	| s |
	s := line stations at: 5.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Gaepo-dong'.
	self assert: s id equals: 'K219'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:37'!
testGuryong

	| s |
	s := line stations at: 4.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Guryong'.
	self assert: s id equals: 'K218'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:35'!
testHanti

	| s |
	s := line stations at: 2.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Hanti'.
	self assert: s id equals: 'K216'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:47'!
testOri

	| s |
	s := line stations at: 18.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Ori'.
	self assert: s id equals: 'K232'! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 9/27/2009 22:33'!
testSeolleung

	| s |
	s := line stations at: 1.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Seolleung'.
	self assert: s id equals: 'K215'! !

!JhcBundangLineTest methodsFor: 'routing' stamp: 'hjo 9/28/2009 12:54'!
testTimeSpanFromBojeongToGaepoDong

	| station1 station2 |
	station1 := line stations at: 5.
	station2 := line stations at: 20.
	self assert: station1 name equals: 'Gaepo-dong'.
	self assert: station2 name equals: 'Bojeong'.
	self assert: (station1 timespanMinutesTo: station2) equals: 40! !

!JhcBundangLineTest methodsFor: 'routing' stamp: 'hjo 9/28/2009 12:16'!
testTimeSpanFromDogokToSeolleung

	| seolleung dogok |
	seolleung := line stations at: 1.
	dogok := line stations at: 3.
	self assert: seolleung name equals: 'Seolleung'.
	self assert: dogok name equals: 'Dogok'.
	self assert: (seolleung timespanMinutesTo: dogok) equals: 4! !

!JhcBundangLineTest methodsFor: 'routing' stamp: 'hjo 9/28/2009 12:23'!
testTimeSpanFromSuseoToKyungwonUniv

	| suseo kyungwonUniv |
	suseo := line stations at: 7.
	kyungwonUniv := line stations at: 9.
	self assert: suseo name equals: 'Suseo'.
	self assert: kyungwonUniv name equals: 'Kyungwon Univ.'.
	self assert: (suseo timespanMinutesTo: kyungwonUniv) equals: 7! !

TestCase subclass: #JhcLine2RingTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine2RingTest methodsFor: 'running' stamp: 'hjo 10/10/2009 08:44'!
setUp

	super setUp.
	line := JhcLine line2Ring! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/8/2009 17:28'!
testAhyeon

	| station |
	station := line stations at: 42.
	self assert: station line equals: '2'.
	self assert: station id equals: '242'.
	self assert: station name equals: 'Ahyeon'.! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/8/2009 17:28'!
testChungjeongno

	| station |
	station := line stations at: 43.
	self assert: station line equals: '2'.
	self assert: station id equals: '243'.
	self assert: station name equals: 'Chungjeongno
(Kyonggi Univ.)
'! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/8/2009 17:15'!
testCityHall

	| station |
	station := line stations at: 1.
	self assert: station name equals: 'City Hall'.
	self assert: station id equals: '201'.
	self assert: station line equals: '2'.! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/8/2009 17:18'!
testEuljiroSamGa

	| station |
	station := line stations at: 3.
	self assert: station name equals: 'Euljiro 3(sam)-ga'.
	self assert: station id equals: '203'.
	self assert: station line equals: '2'.! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/8/2009 17:17'!
testEuljiroilga

	| station |
	station := line stations at: 2.
	self assert: station name equals: 'Euljiro 1(il)-ga'.
	self assert: station id equals: '202'.
	self assert: station line equals: '2'.! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/8/2009 17:27'!
testEwhaWomansUniv

	| station |
	station := line stations at: 41.
	self assert: station line equals: '2'.
	self assert: station id equals: '241'.
	self assert: station name equals: 'Ewha Womans Univ.'.! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/8/2009 19:43'!
testFromCityHallToAhyeon

	| station1 station2 |
	station1 := line stations at: 1.
	station2 := line stations at: 42.
	self assert: (station1 timespanMinutesTo: station2) equals: 2*2! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/10/2009 15:41'!
testFromCityHallToDongdaemun

	| station1 station2 |
	station1 := line stations at: 1.
	station2 := line stations at: 5.
	
	self assert: (station1 timespanMinutesTo: station2) equals: 7! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:16'!
testFromCityHallToSeongnae

	self assert: ((line stationAtName: 'City Hall') timespanMinutesTo: (line stationAtName: 'Seongnae')) equals: 28! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/10/2009 15:51'!
testFromSeongnaeToSindaebang

	self assert: ((line stationAtName: 'Sindaebang') timespanMinutesTo: (line stationAtName: 'Seongnae')) equals: 34! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/10/2009 15:46'!
testFromSindaebangToCityHall

	self assert: ((line stationAtName: 'Sindaebang') timespanMinutesTo: (line stationAtName: 'City Hall')) equals: 29! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/8/2009 19:50'!
testSeongsu

	| station |
	station := line stations at: 11.
	self assert: station line equals: '2'.
	self assert: station id equals: '211'.
	self assert: station name equals: 'Seongsu'! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/8/2009 19:51'!
testSindorim

	| station |
	station := line stations at: 34.
	self assert: station line equals: '2'.
	self assert: station id equals: '234'.
	self assert: station name equals: 'Sindorim'! !

TestCase subclass: #JhcLine2SeongsuBranchTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine2SeongsuBranchTest methodsFor: 'running' stamp: 'hjo 10/8/2009 19:53'!
setUp

	super setUp.
	line := JhcLine line2SeongsuBranch! !

!JhcLine2SeongsuBranchTest methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:28'!
testFromSeongsuToSinseolDong

	self assert: ((line stationAtName: 'Seongsu') timespanMinutesTo: (line stationAtName: 'Sinseol-dong')) equals: 9! !

!JhcLine2SeongsuBranchTest methodsFor: 'routing' stamp: 'hjo 10/9/2009 23:34'!
testFromSinseolDongToYongdap

	| station1 station2 |
	station1 := line stations at: 5.
	station2 := line stations at: 2.
	self assert: (station1 timespanMinutesTo: station2) equals: 6! !

!JhcLine2SeongsuBranchTest methodsFor: 'routing' stamp: 'hjo 10/9/2009 23:34'!
testFromYongdapToSindap

	| station1 station2 |
	station1 := line stations at: 3.
	station2 := line stations at: 2.
	self assert: (station1 timespanMinutesTo: station2) equals: 2! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/8/2009 19:59'!
testSeongsu

	| station |
	station := line stations at: 1.
	self assert: station line equals: '2'.
	self assert: station id equals: '211'.
	self assert: station name equals: 'Seongsu'.! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/9/2009 22:15'!
testSindap

	| station |
	station := line stations at: 3.
	self assert: station line equals:  '2'.
	self assert: station id equals: '211-2'.
	self assert: station name equals: 'Sindap'! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/9/2009 22:40'!
testSinseoldong

	| station |
	station := line stations at: 5.
	self assert: station line equals:  '2'.
	self assert: station id equals: '211-4'.
	self assert: station name equals: 'Sinseol-dong'! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/9/2009 22:14'!
testYongdap

	| station |
	station := line stations at: 2.
	self assert: station line equals:  '2'.
	self assert: station id equals: '211-1'.
	self assert: station name equals: 'Yongdap'! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/9/2009 22:48'!
testYongdu

	| station |
	station := line stations at: 4.
	self assert: station line equals:  '2'.
	self assert: station id equals: '211-3'.
	self assert: station name equals: 'Yongdu'! !

TestCase subclass: #JhcLine2SinjeongBranchTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine2SinjeongBranchTest methodsFor: 'running' stamp: 'hjo 10/9/2009 22:18'!
setUp

	super setUp.
	line := JhcLine line2SinjeongBranch! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/9/2009 22:48'!
testDorimcheon

	| station |
	station := line stations at: 2.
	self assert: station line equals: '2'.
	self assert: station id equals: '234-1'.
	self assert: station name equals: 'Dorimcheon'! !

!JhcLine2SinjeongBranchTest methodsFor: 'routing' stamp: 'hjo 10/10/2009 15:49'!
testFromDorimcheonToSinjeongnegeori

	| station1 station2 |
	station1 := line stations at: 2.
	station2 := line stations at: 4.
	self assert: (station1 timespanMinutesTo: station2) equals: 7! !

!JhcLine2SinjeongBranchTest methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:28'!
testFromSindorimToKkachisan

	self assert: ((line stationAtName: 'Sindorim') timespanMinutesTo: (line stationAtName: 'Kkachisan')) equals: 12! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/9/2009 22:34'!
testKkachisan

	| station |
	station := line stations at: 5.
	self assert: station line equals: '2'.
	self assert: station id equals: '234-4'.
	self assert: station name equals: 'Kkachisan'! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/9/2009 22:20'!
testSindorim

	| station |
	station := line stations at: 1.
	self assert: station line equals: '2'.
	self assert: station id equals: '234'.
	self assert: station name equals: 'Sindorim'! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/9/2009 22:34'!
testSinjeongnegeori

	| station |
	station := line stations at: 4.
	self assert: station line equals: '2'.
	self assert: station id equals: '234-3'.
	self assert: station name equals: 'Sinjeongnegeori'! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/9/2009 23:04'!
testYangcheonGuOffice

	| station |
	station := line stations at: 3.
	self assert: station line equals: '2'.
	self assert: station id equals: '234-2'.
	self assert: station name equals: 'Yangcheon-gu Office'! !

TestCase subclass: #JhcLine2Test
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine2Test methodsFor: 'running' stamp: 'hjo 10/10/2009 08:46'!
setUp

	super setUp.
	line := JhcLine line2! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 15:54'!
testFromMullaeToDorimcheon

	| dorimcheon mullae |
	mullae := line stationAtName: 'Mullae'.
	dorimcheon := line stationAtName: 'Dorimcheon'.
	
	self assert: (mullae timespanMinutesTo: dorimcheon) equals: 18! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 15:53'!
testFromWangsimniToSindap

	| wang sindap |
	wang := line stationAtName: 'Wangsimni'.
	sindap := line stationAtName: 'Sindap'.
	
	self assert: (wang timespanMinutesTo: sindap) equals: 22! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 09:02'!
testStationsOfEachPartExist

	self shouldnt: [line stations detect: [:each| each name = 'Wangsimni' ]] raise: Error.
	self shouldnt: [line stations detect: [:each| each name = 'Yongdap' ]] raise: Error.
	self shouldnt: [line stations detect: [:each| each name = 'Dorimcheon' ]] raise: Error	! !

TestCase subclass: #JhcLine3Test
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:12'!
setUp
	line := JhcLine line3! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 10:25'!
testFromDaehwaToJeongbalsan
	self assert: (self timeFrom: 'Daehwa' to: 'Jeongbalsan') equals: 5.! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 10:25'!
testFromDaehwaToMadu

	self assert: (self timeFrom: 'Daehwa' to: 'Madu') equals: 7.! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 10:20'!
testFromDaehwaToSuseo
	self assert: (self timeFrom: 'Daehwa' to: 'Suseo') equals: 90! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:11'!
testLineId
	self assert: ('3' = line line)! !

!JhcLine3Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 10:21'!
timeFrom: from to: to
	| fromStation toStation |
	fromStation := line stationAtName: from.
	toStation := line stationAtName: to.
	^fromStation timespanMinutesTo: toStation! !

TestCase subclass: #JhcLine6Test
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine6Test methodsFor: 'running' stamp: 'hjo 9/28/2009 18:59'!
setUp

	super setUp.
	line := JhcLine line6! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/29/2009 10:12'!
testBonghwasan

	| station |
	station := line stations at: 38.
	self assert: station line equals: '6'.
	self assert: station id equals: '647'.
	self assert: station name equals: 'Bonghwasan'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/28/2009 19:15'!
testEungam

	| station |
	station := line stations at: 1.
	self assert: station line equals: '6'.
	self assert: station id equals: '610'.
	self assert: station name equals: 'Eungam'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/29/2009 11:26'!
testGusan

	| station |
	station := line stations at: 6.
	self assert: station line equals: '6'.
	self assert: station id equals: '615'.
	self assert: station name equals: 'Gusan'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/8/2009 16:19'!
testMangwon

	| station |
	station := line stations at: 12.
	self assert: station line equals: '6'.
	self assert: station id equals: '621'.
	self assert: station name equals: 'Mangwon'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/28/2009 19:16'!
testSaejeol

	| station |
	station := line stations at: 7.
	self assert: station line equals: '6'.
	self assert: station id equals: '616'.
	self assert: station name equals: 'Saejeol
(Sinsa)'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/29/2009 10:55'!
testStraightLineStations

	self assert: (line stations at: 1) name equals: 'Eungam'.
	self assert: (line stations at: 7) name equals: 'Saejeol
(Sinsa)'.
	self assert: (line stations at: 8) name equals: 'Jeungsan
(Myongji Univ.)'.
	self assert: (line stations at: 9) name equals: 'Digital Media City'.
	"..."
	self assert: (line stations at: 36) name equals: 'Taereung'.
	self assert: (line stations at: 37) name equals: 'Hwarangdae
(Seoul Women''s Univ.)'..
	self assert: (line stations at: 38) name equals: 'Bonghwasan'.! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 9/29/2009 11:15'!
testTimeSpanFromEungamToBonghwasan

	| station1 station2 |
	station1 := line stations at: 1.
	station2 := line stations at: 38.
		
	self assert: (station1 timespanMinutesTo: station2) equals: 64! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 9/29/2009 11:32'!
testTimeSpanFromYeokchonToGusan

	| station1 station2 |
	station1 := line stations at: 2.
	station2 := line stations at: 6.
		
	self assert: (station1 timespanMinutesTo: station2) equals: 9! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 9/29/2009 11:38'!
testTimeSpanFromYeokchonToSaejeol

	| station1 station2 |
	station1 := line stations at: 2.
	station2 := line stations at: 7.
		
	self assert: (station1 timespanMinutesTo: station2) equals: 14! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 9/29/2009 11:27'!
testYeokchon

	| station |
	station := line stations at: 2.
	self assert: station line equals: '6'.
	self assert: station id equals: '611'.
	self assert: station name equals: 'Yeokchon'! !

TestCase subclass: #JhcLine7Test
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine7Test methodsFor: 'running' stamp: 'hjo 10/10/2009 09:23'!
setUp

	super setUp.
	line := JhcLine line7! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 10:20'!
testChildrensGrandPark

	| station |
	station := line stations at: 18.
	self assert: station line equals: '7'.
	self assert: station id equals: '726'.
	self assert: station name equals: 'Children''s Grand Park'! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 10:11'!
testDobongsan

	| station |
	station := line stations at: 2.
	self assert: station line equals: '7'.
	self assert: station id equals: '710'.
	self assert: station name equals: 'Dobongsan'! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:05'!
testFirstStationIsConnected

	self assert: line stations first graphVertex edges size = 1! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:06'!
testFromJunghwaToCheongdam

	| station1 station2 |
	station1 := line stationAtName: 'Junghwa'.
	station2 := line stationAtName: 'Cheongdam'.
	self assert: (station1 timespanMinutesTo: station2) equals: 20! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:07'!
testIntermediateStationIsConnectedTwice

	line stations copyWithoutFirst copyWithoutLast
		do: [:each| self assert: each graphVertex edges size = 2]! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 09:30'!
testJangam

	| station |
	station := line stations at: 1.
	self assert: station line equals: '7'.
	self assert: station id equals: '709'.
	self assert: station name equals: 'Jangam'! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 10/10/2009 12:04'!
testLastStationIsConnected

	self assert: line stations last graphVertex edges size = 1! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 10:36'!
testOnsu

	| station |
	station := line stations at: 42.
	self assert: station line equals: '7'.
	self assert: station id equals: '750'.
	self assert: station name equals: 'Onsu'! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/10/2009 10:11'!
testSuraksan

	| station |
	station := line stations at: 3.
	self assert: station line equals: '7'.
	self assert: station id equals: '711'.
	self assert: station name equals: 'Suraksan'! !

TestCase subclass: #JhcLine8Test
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine8Test methodsFor: 'running' stamp: 'hjo 9/28/2009 13:16'!
setUp

	super setUp.
	line := JhcLine line8! !

!JhcLine8Test methodsFor: 'station' stamp: 'hjo 9/28/2009 13:29'!
testAmsa

	| station |
	station := line stations at: 1.
	self assert: station line equals: '8'.
	self assert: station name equals: 'Amsa'.
	self assert: station id equals: '810'! !

!JhcLine8Test methodsFor: 'station' stamp: 'hjo 9/28/2009 15:05'!
testSongpa

	| station |
	station := line stations at: 7.
	self assert: station line equals: '8'.
	self assert: station name equals: 'Songpa'.
	self assert: station id equals: '816'! !

!JhcLine8Test methodsFor: 'etc' stamp: 'hjo 9/29/2009 11:10'!
testStationAndVertexHandshake

	| station |
	station := JhcStation new.
	self assert: (station graphVertex isKindOf: Vertex).
	self assert: (station graphVertex masterObject == station)! !

!JhcLine8Test methodsFor: 'routing' stamp: 'hjo 9/28/2009 15:20'!
testTimeSpanFromAmsaToSongpa

	| station1 station2 |
	station1 := line stations at: 1.
	station2 := line stations at: 7.

	self assert: (station1 timespanMinutesTo: station2) equals: 13! !

!JhcLine8Test methodsFor: 'routing' stamp: 'hjo 9/28/2009 15:21'!
testTimeSpanFromBokjeongToSanseong

	| station1 station2 |
	station1 := line stations at: 11.
	station2 := line stations at: 12.

	self assert: (station1 timespanMinutesTo: station2) equals: 4! !

TestCase subclass: #JhcLineJooyungHanTest
	instanceVariableNames: 'line scrum tdd refactoring pp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLineJooyungHanTest methodsFor: 'running' stamp: 'jhan 10/12/2009 00:31'!
setUp

	| input |
	input := 'jh01	Refactoring	2
jh02	TDD	2
jh03	PP	2
jh04	Scrum	2'.
	line := JhcLine loadData: input for: 'Jooyung Han'.
	
	scrum := line stationAtName: 'Scrum'.
	tdd := line stationAtName: 'TDD'.
	refactoring := line stationAtName: 'Refactoring'.
	pp := line stationAtName: 'PP'.
	! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:48'!
testCircularLine
	self assert: (refactoring neighbors includes: tdd).
	self assert: (tdd neighbors includes: pp).
	self assert: (pp neighbors includes: scrum).
	self assert: (scrum neighbors includes: refactoring).! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:26'!
testStationCount
	self assert:4 equals: line stations size! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 01:04'!
testTimeSpan
	|cost|
	cost := JhcStation defaultCost.
	self assert: 0 equals: (refactoring timespanMinutesTo: refactoring).
	self assert: cost equals: (refactoring timespanMinutesTo: tdd).
	self assert: cost*2 equals: (refactoring timespanMinutesTo: pp).! !

TestCase subclass: #JhcLineTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLineTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:59'!
testLoadInput
	| input |
	input := '310	Daehwa	0'.
	line := JhcLine loadData: input for: '3'.
	self assert: (line line = '3').
	self assert: line stations size equals: 1.
	self assert: line stations first id equals: '310'.! !

!JhcLineTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:43'!
testReadStream
	| lines |
	
	lines := '3
abc	def	ghi' lines.
	self assert: (lines size = 2)
	! !

TestCase subclass: #JhcRoutingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 09:28'!
testBundangLine

	| line |
	line := OrderedCollection new.
	line add: (JhcStation newName: 'Seolleung' line: 'Bundang' id: 'K215').
	line add: (JhcStation newName: 'Hanti' line: 'Bundang' id: 'K216').
	line add: (JhcStation newName: 'Dogok' line: 'Bundang' id: 'K217').
	line add: (JhcStation newName: 'Guryong' line: 'Bundang' id: 'K218').
	line add: (JhcStation newName: 'Gaepo-dong' line: 'Bundang' id: 'K219').
	line add: (JhcStation newName: 'Daemosan' line: 'Bundang' id: 'K220').
	line add: (JhcStation newName: 'Suseo' line: 'Bundang' id: 'K221').
	line add: (JhcStation newName: 'Bokjeong' line: 'Bundang' id: 'K222').
	line add: (JhcStation newName: 'Kyungwon Univ.' line: 'Bundang' id: 'K223').
	line add: (JhcStation newName: 'Taepyeong' line: 'Bundang' id: 'K224').
	line add: (JhcStation newName: 'Moran' line: 'Bundang' id: 'K225').
	line add: (JhcStation newName: 'Yatap' line: 'Bundang' id: 'K226').
	line add: (JhcStation newName: 'Imae' line: 'Bundang' id: 'K227').
	line add: (JhcStation newName: 'Seohyeon' line: 'Bundang' id: 'K228').
	line add: (JhcStation newName: 'Sunae' line: 'Bundang' id: 'K229').
	line add: (JhcStation newName: 'Jeongja' line: 'Bundang' id: 'K230').
	line add: (JhcStation newName: 'Migeum' line: 'Bundang' id: 'K231').
	line add: (JhcStation newName: 'Ori' line: 'Bundang' id: 'K232').
	line add: (JhcStation newName: 'Jukjeon' line: 'Bundang' id: 'K233').
	line add: (JhcStation newName: 'Bojeong' line: 'Bundang' id: 'K234').

	line doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	
	self assert: ((line at:1) timespanMinutesTo: (line at:15)) equals: 28! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 11:25'!
testLine8

	| line |
	line := OrderedCollection new.
	line add: (JhcStation newName: 'Amsa' line: '8' id: '810').
	line add: (JhcStation newName: 'Cheonho(Pungnaptoseong)' line: '8' id: '811').
	line add: (JhcStation newName: 'Gangdong-gu Office' line: '8' id: '812').
	line add: (JhcStation newName: 'Mongchontoseong(World Peace Gate)' line: '8' id: '813').
	line add: (JhcStation newName: 'Jamsil(Songpa-gu Office)' line: '8' id: '814').
	line add: (JhcStation newName: 'Seokchon' line: '8' id: '815').
	line add: (JhcStation newName: 'Songpa' line: '8' id: '816').
	line add: (JhcStation newName: 'Garak Market' line: '8' id: '817').
	line add: (JhcStation newName: 'Munjeong' line: '8' id: '818').
	line add: (JhcStation newName: 'Jangji' line: '8' id: '819').
	line add: (JhcStation newName: 'Bokjeong' line: '8' id: '820').
	line add: (JhcStation newName: 'Sanseong' line: '8' id: '821').
	line add: (JhcStation newName: 'Namhansanseong(Seongnam Court & Public Prosecutor''s Office)' line: '8' id: '822').
	line add: (JhcStation newName: 'Dandaegogeori' line: '8' id: '823').
	line add: (JhcStation newName: 'Sinheung' line: '8' id: '824').
	line add: (JhcStation newName: 'Sujin' line: '8' id: '825').
	line add: (JhcStation newName: 'Moran' line: '8' id: '826').

	line doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	
	self assert: ((line at:10) timespanMinutesTo: (line at:15)) equals: 10! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:27'!
testOneSegment

	| s t g |
	s := JhcStation newName: 'Hapjeong' line: 2 id: 238.
	t := JhcStation newName: 'HongIk Univ.' line: 2 id: 239.
	g := JhcSegment newTimespanMinutes: 2.

	s setStationAccess: t in: g.
	self assert: (s timespanMinutesTo: t) equals:2! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 11:34'!
testTransferFromBundangLineToLine8AtBokjeong

	| line8 bundangLine |
	line8 := OrderedCollection new.
	line8 add: (JhcStation newName: 'Munjeong' line: '8' id: '818').
	line8 add: (JhcStation newName: 'Jangji' line: '8' id: '819').
	line8 add: (JhcStation newName: 'Bokjeong' line: '8' id: '820').
	line8 add: (JhcStation newName: 'Sanseong' line: '8' id: '821').
	line8 add: (JhcStation newName: 'Namhansanseong(Seongnam Court & Public Prosecutor''s Office)' line: '8' id: '822').

	line8 doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	
	bundangLine := OrderedCollection new.
	bundangLine add: (JhcStation newName: 'Gaepo-dong' line: 'Bundang' id: 'K219').
	bundangLine add: (JhcStation newName: 'Daemosan' line: 'Bundang' id: 'K220').
	bundangLine add: (JhcStation newName: 'Suseo' line: 'Bundang' id: 'K221').
	bundangLine add: (JhcStation newName: 'Bokjeong' line: 'Bundang' id: 'K222').
	bundangLine add: (JhcStation newName: 'Kyungwon Univ.' line: 'Bundang' id: 'K223').
	bundangLine add: (JhcStation newName: 'Taepyeong' line: 'Bundang' id: 'K224').
	bundangLine add: (JhcStation newName: 'Moran' line: 'Bundang' id: 'K225').

	bundangLine doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	(line8 at: 3) graphVertex connect: (bundangLine at: 4) graphVertex cost: 7. "transfer link"
	
	self assert: (line8 first timespanMinutesTo: bundangLine last) equals: 17! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/26/2009 19:45'!
testTwoSegment

	| s t u |
	s := JhcStation newName: 'Hapjeong' line: 2 id: 238.
	t := JhcStation newName: 'HongIk Univ.' line: 2 id: 239.
	u := JhcStation newName: 'ShinChon' line: 2 id: 240.

	self revisit: 'I think JhcSegment is not doing anything here. Simply CostEdge will be good enough.'.

	s graphVertex connect: t graphVertex cost: 2.
	t graphVertex connect: u graphVertex cost: 2.
	self assert: (s timespanMinutesTo: u) equals: 4! !

Object subclass: #IntegerStream
	instanceVariableNames: 'current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'hjo 10/7/2009 21:00'!
current: aSmallInteger 

	current := aSmallInteger ! !

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:35'!
initialize
	current := 0! !

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:35'!
next
	|ret|
	ret := current.
	current := current + 1.
	^ret! !

Object subclass: #JhcLine
	instanceVariableNames: 'line idPrefix stations integerStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/7/2009 21:06'!
bundang

	| inst |
	inst := self new.
	inst line: 'Bundang'.
	inst idPrefix: 'K'.
	inst setIntegerForFirstStationId: 215.
	
	#('Seolleung' 'Hanti' 'Dogok' 'Guryong' 'Gaepo-dong' 'Daemosan' 'Suseo' 'Bokjeong' 'Kyungwon Univ.' 'Taepyeong' 'Moran' 'Yatap' 'Imae' 'Seohyeon' 'Sunae' 'Jeongja' 'Migeum' 'Ori' 'Jukjeon' 'Bojeong') do: [ :each | 
		inst addStationNamed: each ].
	inst connectStationsWithEdgesWithTimeSpanMinutes: #(2 2 2 2 2 4 4 3 2 2 3 3 2 2 3 3 2 3 2).
	^inst! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 15:17'!
connctStations: anArray withMinuteStream: aReadStream 

	self assert: [aReadStream size + 1 = anArray size ] description: 'number of edges are one less than number of vertices.'.
	anArray doCouple: [:a :b| a connect: b cost: aReadStream next ]! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 15:54'!
line2

	| ring seongsu sinjeong instance |
	ring := self line2Ring.
	seongsu := self line2SeongsuBranch.
	sinjeong := self line2SinjeongBranch.
	instance := self new.
	instance line: '2'.

	instance stations addAll: ring stations.
	instance stations addAll: seongsu stations.
	instance stations addAll: sinjeong stations.

	(ring stationAtId: '234') connect: (sinjeong stationAtId: '234') cost: 13.
	(seongsu stationAtId: '211') connect: (ring stationAtId: '211') cost: 11.

	^instance! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 15:38'!
line2Ring

	| instance |
	instance := self new.
	instance line: '2'.
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 201.
	
	#('City Hall' 'Euljiro 1(il)-ga' 'Euljiro 3(sam)-ga' 'Euljiro 4(sa)-ga' 'Dongdaemun Stadium' 'Sindang' 'Sangwangsimni' 'Wangsimni' 'Hanyang Univ.' 'Ttukseom' 'Seongsu' 'Konkuk Univ.' 'Guui
(Gwangjin-gu Office)
' 'Gangbyeon
(Dongseoul Bus Terminal)
' 'Seongnae' 'Jamsil
(Songpa-gu Office)
' 'Sincheon' 'Sports Complex'  'Samseong
(World Trade Center Seoul)
' 'Seolleung' 'Yeoksam' 'Gangnam' 'Seoul Nat''l Univ. of Education
(Court &Public Prosecutor''s Office)
' 'Seocho' 'Bangbae' 'Sadang' 'Nakseongdae' 'Seoul Nat''l Univ.
(Gwanak-gu Office)
' 'Bongcheon' 'Sillim' 'Sindaebang' 'Guro Digital Complex' 'Daerim
(Guro-gu Office)
' 'Sindorim' 'Mullae' 'Yeongdeungpo-gu Office' 'Dangsan' 'Hapjeong' 'Hongik Univ.' 'Sinchon' 'Ewha Womans Univ.' 'Ahyeon' 'Chungjeongno
(Kyonggi Univ.)
')
		do: [:each| instance addStationNamed: each ].
	instance connectStationsInRange: (1 to: 43), (Array with: 1) withEdgesWithTimeSpanMinutes:  #(2 2 1 2 2 2 1 2 3 1 2 3 2 3 3 2 2 2 2 2 2 2 1 3 3 2 2 2 2 2 2 2 3 3 1 2 4 2 3 2 1 2 2).

	^instance! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 15:51'!
line2SeongsuBranch

	| instance |
	instance := self new.
	instance line: '2'.
	
	#(
		('Seongsu' '211')
		('Yongdap' '211-1')
		('Sindap' '211-2')
		('Yongdu' '211-3')
		('Sinseol-dong' '211-4')
	)
		do: [:data| 
			instance addStationNamed: data first id: data second.
			].
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(3 2 2 2).
	^instance
	! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 15:48'!
line2SinjeongBranch

	| instance |
	instance := self new.
	instance line: '2'.
	
	#(
		('Sindorim' '234')
		('Dorimcheon' '234-1')
		('Yangcheon-gu Office' '234-2')
		('Sinjeongnegeori' '234-3')
		('Kkachisan' '234-4')
	)
		do: [:data| 
			instance addStationNamed: data first id: data second ].
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(2 3 4 3).
	^instance
	! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 10:18'!
line3
	| input |
	
	input := '310	Daehwa	0
311	Juyeop	2
312	Jeongbalsan	3
313	Madu	2
314	Baekseok	2
315	Daegok	4
316	Hawjeong	3
317	Wondang	3
318	Samsong	5
319	Jichuk	3
320	Gupabal	4
321	Yeonshinnae	2
322	Bulgwang	2
323	Nokbeon	2
324	Hongje	3
325	Muakjae	2
326	Dongnimmun	2
327	Gyeongbokgung	2
328	Anguk	2
329	Jongno 3(sam)-ga	2
330	Euljiro 3(sam)-ga	2
331	Chungmuro	1
332	Dongguk Univ.	3
333	Yaksu	1
334	Geumho	1
335	Oksu	2
336	Apgujeong	2
337	Sinsa	3
338	Jamwon	2
339	Express Bus Terminal	2
340	Seoul Nat''l Univ. of Education	2
341	Nambu Bus Terminal	2
342	Yangjae	3
343	Maebong	2
344	Dogok	2
345	Daechi	2
346	Hangnyeoul	1
347	Daecheng	2
348	Irwon	2
349	Suseo	3'.
		
		^self loadData: input for: '3'! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/7/2009 21:06'!
line6
	
	| instance |
	instance := self new.
	instance line: '6'.
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 610.
	#('Eungam' 'Yeokchon' 'Bulgwang' 'Dokbawi' 'Yeonsinnae' 'Gusan' 'Saejeol
(Sinsa)' 'Jeungsan
(Myongji Univ.)'	 'Digital Media City' 'World Cup Stadium
(Seongsan)' 'Mapo-gu Office' 'Mangwon' 'Hapjeong' 'Sangsu' 'Gwangheungchang (Seogang)' 'Daeheung
(Sogang Univ.)' 'Gongdeok' 'Hyochang Park
(Yongsan-gu Office)' 'Samgakji' 'Noksapyeong' 'Itaewon' 'Hangangjin' 'Beotigogae' 'Yaksu' 'Cheonggu' 'Sindang' 'Dongmyo' 'Changsin' 'Bomun' 'Anam
(Korea Univ. Hospital)' 'Korea Univ.
(Jongam)' 'Wolgok
(Dongduk Women''s Univ.)'	 'Sangwolgok
(KIST)' 'Dolgoji' 'Seokgye' 'Taereung' 'Hwarangdae
(Seoul Women''s Univ.)' 'Bonghwasan') do: [ :each | 
		instance addStationNamed: each ].
	instance connectStationsInRange: (Array with: 1), (7 to: 38) withEdgesWithTimeSpanMinutes: (32 copiesOf: 2).
	instance connectStationsWithDirectionInRange: (1 to: 6) , (1 to: 1) withEdgesWithTimeSpanMinutes: #(2 2 2 3 2 3).
	^instance! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 12:04'!
line7

	| instance |
	instance := self new.
	instance line: '7'.
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 709. "?"

	#(	'Jangam' 'Dobongsan' 'Suraksan' 'Madeul' 'Nowon' 'Junggye'
	'Hagye' 'Gongneung' 'Taereung' 'Meokgol' 'Junghwa' 'Sangbong'
	'Myeonmok' 'Sagajeong' 'Yongmasan' 'Junggok' 'Gunja' 'Children''s Grand Park'
	'Konkuk Univ.' 'Ttukseom Resort' 'Cheongdam' 'Gangnam-gu Office' 'Hak-dong'
	'Nonhyeon' 'Banpo' 'Express Bus Terminal' 'Naebang' 'Isu' 'Namseong'
	'Soongsil Univ.' 'Sangdo' 'Jangseungbaegi' 'Sindaebangsamgeori' 'Boramae'
	'Sinpung' 'Daerim' 'Namguro' 'Gasan Digital Complex' 'Cheolsan' 'Gwangmyeongsageori'
	'Cheonwang' 'Onsu'
	)
		do: [:stationName| 
			instance addStationNamed: stationName ].
	instance connectStationsWithEdgesWithTimeSpanMinutes:  #(3 2 2 2 2 2 1 2 2 2 2 2 1 2 2 2 2 2 3 2 1 2 2 2 3 2 2 3 1 2 3 1 2 3 2 1 3 2 3 3 2).
	^instance! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/7/2009 21:05'!
line8

	| instance |
	instance := self new.
	instance line: '8'.
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 810.
	
	#('Amsa' 'Cheonho(Pungnaptoseong)' 'Gangdong-gu Office' 'Mongchontoseong(World Peace Gate)' 'Jamsil(Songpa-gu Office)' 'Seokchon' 'Songpa' 'Garak Market' 'Munjeong' 'Jangji' 'Bokjeong' 'Sanseong' 'Namhansanseong(Seongnam Court & Public Prosecutor''s Office)' 'Dandaegogeori' 'Sinheung' 'Sujin' 'Moran') do: [ :each | 
		instance addStationNamed: each ].
	
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(2 2 3 2 2 2 2 2 2 2 4 3 2 2 2 2).
	^instance! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 00:36'!
loadData: input for: lineId
	| line stations prevStation nextStation firstStation |
	line := self new.
	line line: lineId.
	
	stations := input lines collect: [ :each |
			self parseInputLine: each
		].
	
	"add first station"
	firstStation := line addStationNamed: stations first second
								id: stations first first.
								
	stations doCouple: [:prev :next|
		prevStation := line stationAtName: prev second.
		nextStation := line addStationNamed: next second id: next first.
		prevStation connect: nextStation cost: next third asNumber.
		].
	
	"if the line is circular one, then connect first and last stations"
	(stations first third = '0') ifFalse: [
		line stations first connect: line stations last cost: stations first third asNumber].
	^line! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 00:24'!
parseInputLine: line
	^line subStrings: Character tab asString! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 00:50'!
addStationNamed: aByteString 
	^self addStationNamed: aByteString idNumber: self nextIdNumber! !

!JhcLine methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 22:06'!
addStationNamed: aByteString id: niceIdString

	^stations add: (JhcStation newName: aByteString line: line id: niceIdString)! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 00:49'!
addStationNamed: aByteString idNumber: aSmallInteger 

	^stations add: (JhcStation newName: aByteString line: line id: idPrefix , aSmallInteger printString)
! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/10/2009 15:13'!
connectStationsInRange: indicesOfStation withEdgesWithTimeSpanMinutes: minutes 

	self class connctStations: (indicesOfStation collect: [:each| stations at: each]) withMinuteStream: minutes readStream! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:12'!
connectStationsWithDirectionInRange: indicesOfStation withEdgesWithTimeSpanMinutes: minutes 

	| minutesStream |
	minutesStream := minutes readStream.
	(indicesOfStation collect: [:each| stations at: each]) doCouple: [:a :b| a connectTo: b  cost: minutesStream next ].! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/10/2009 15:15'!
connectStationsWithEdgesTimeSpan2Minutes

	self class connctStations: stations withMinuteStream: (stations size copiesOf: 2) readStream! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/10/2009 15:40'!
connectStationsWithEdgesWithTimeSpanMinutes: anArray 

	self class connctStations: stations withMinuteStream: anArray readStream! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 21:58'!
idPrefix: aByteString 

	idPrefix := aByteString ! !

!JhcLine methodsFor: 'initialize-release' stamp: 'hjo 9/27/2009 22:00'!
initialize

	super initialize.
	stations := OrderedCollection new! !

!JhcLine methodsFor: 'accessing' stamp: 'jhan 10/2/2009 00:33'!
integerStream
	integerStream isNil ifTrue: [ integerStream := IntegerStream new ].
	^integerStream! !

!JhcLine methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:11'!
line
	^line! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 21:58'!
line: aByteString 

	line :=  aByteString ! !

!JhcLine methodsFor: 'query' stamp: 'jhan 10/2/2009 00:48'!
neighbors
	self shouldBeImplemented! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 00:32'!
nextIdNumber
	^self integerStream next! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 10/7/2009 21:02'!
setIntegerForFirstStationId: aSmallInteger 

	self integerStream current: aSmallInteger! !

!JhcLine methodsFor: 'query' stamp: 'hjo 10/10/2009 08:59'!
stationAtId: aByteString 

	^stations detect: [:each| each id = aByteString]! !

!JhcLine methodsFor: 'query' stamp: 'hjo 10/10/2009 09:06'!
stationAtName: aByteString 

	^self stations detect: [:each| each name = aByteString ]! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 22:27'!
stations

	^stations! !

Object subclass: #JhcSegment
	instanceVariableNames: 'timespanMinutes graphEdge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcSegment classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:15'!
newTimespanMinutes: aNumber

	^self new
		timespanMinutes: aNumber 

	! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 18:52'!
graphEdge

	^graphEdge! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 10:02'!
initialize

	super initialize.
	graphEdge := CostEdge new.
	graphEdge masterObject: self! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:22'!
timespanMinutes

	^timespanMinutes! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/26/2009 19:36'!
timespanMinutes: aNumber

	self revisit: 'duplicate information!!'.
	timespanMinutes := aNumber.
	graphEdge cost: aNumber! !

Object subclass: #JhcStation
	instanceVariableNames: 'name id line graphVertex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 01:03'!
defaultCost
	^2! !

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 09:34'!
newName: aByteString id: aByteString2 

	self revisit: 'DELETE ME!!'! !

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 18:05'!
newName: aByteString line: aSmallInteger id: aSmallInteger3 

	^self new
		name: aByteString;
		line: aSmallInteger;
		id: aSmallInteger3! !

!JhcStation methodsFor: 'testing' stamp: 'jhan 10/2/2009 01:06'!
canDirectlyGo: aJhcStation
	^graphVertex neighboringVertices anySatisfy: [:each| each masterObject = aJhcStation]! !

!JhcStation methodsFor: 'testing' stamp: 'hjo 9/26/2009 19:27'!
canGo: aJhcStation in: aJhcSegment 

	^graphVertex leavingEdges anySatisfy: [:each| each masterObject == aJhcSegment ]
! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:03'!
connect: aJhcStation 
	self connect: aJhcStation cost: self class defaultCost! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:00'!
connect: other cost: c 
	self graphVertex connect: other graphVertex cost: c! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:14'!
connectTo: otherStation cost: aSmallInteger 
	self graphVertex connectTo: otherStation graphVertex cost: aSmallInteger! !

!JhcStation methodsFor: 'printing' stamp: 'hjo 10/8/2009 16:16'!
detailPrintStringForVertex

	^name! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/26/2009 19:30'!
graphVertex

	^graphVertex! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/27/2009 22:31'!
id

	^id! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
id: aSmallInteger 

	id := aSmallInteger! !

!JhcStation methodsFor: 'initialize-release' stamp: 'hjo 9/29/2009 11:11'!
initialize

	super initialize.
	graphVertex := CostVertex new.
	graphVertex masterObject: self! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/18/2009 13:47'!
line

	^line! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
line: aSmallInteger 

	line := aSmallInteger! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:01'!
name

	^name! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
name: aByteString 
	name := aByteString! !

!JhcStation methodsFor: 'querying' stamp: 'jhan 10/2/2009 00:54'!
neighbors
	^self graphVertex neighbors collect: [ :neighbor | neighbor masterObject ]! !

!JhcStation methodsFor: 'printing' stamp: 'hjo 9/28/2009 12:38'!
printVertexDetailOn: aStream

	aStream print: name! !

!JhcStation methodsFor: 'collecting' stamp: 'hjo 9/26/2009 20:18'!
setStationAccess: aJhcStation in: aJhcSegment 

	aJhcSegment graphEdge connect: self graphVertex and: aJhcStation graphVertex.
	self assert: [self graphVertex hasEdge: aJhcSegment graphEdge] description: 'Hand shake?'.
	self assert: [aJhcStation graphVertex hasEdge: aJhcSegment graphEdge] description: 'Hand shake?'! !

!JhcStation methodsFor: 'querying' stamp: 'hjo 9/29/2009 11:10'!
timespanMinutesTo: aJhcStation 

	self revisit: 'CostVertices in the Graph must be initialized some how.'.
	aJhcStation graphVertex computeMinimumCostGraphPathsFrom: self graphVertex.
	^aJhcStation graphVertex minimumCost! !
